var append, checkValidComponent, checkValidOp, compose, compress, invertComponent, makeComposable, strInject, text;
text = {};
text.name = 'text-fast';
text.initialVersion = function() {
  return '';
};
strInject = function(s1, pos, s2) {
  return s1.slice(0, pos) + s2 + s1.slice(pos);
};
checkValidComponent = function(c) {
  var d_type, i_type;
  if (typeof c['p'] !== 'number') {
    throw new Error('component missing position field');
  }
  i_type = typeof c['i'];
  d_type = typeof c['d'];
  if (!((i_type === 'string') ^ (d_type === 'string'))) {
    throw new Error('component needs an i or d field');
  }
  if (!(c['p'] >= 0)) {
    throw new Error('position cannot be negative');
  }
};
checkValidOp = function(op) {
  var c, _i, _len;
  for (_i = 0, _len = op.length; _i < _len; _i++) {
    c = op[_i];
    checkValidComponent(c);
  }
  return true;
};
text.apply = function(snapshot, op) {
  var component, deleted, _i, _len;
  checkValidOp(op);
  for (_i = 0, _len = op.length; _i < _len; _i++) {
    component = op[_i];
    if (component['i'] != null) {
      snapshot = strInject(snapshot, component['p'], component['i']);
    } else {
      deleted = snapshot.slice(component['p'], component['p'] + component['d'].length);
      if (component['d'] !== deleted) {
        throw new Error("Delete component '" + component['d'] + "' does not match deleted text '" + deleted + "'");
      }
      snapshot = snapshot.slice(0, component['p']) + snapshot.slice(component['p'] + component['d'].length);
    }
  }
  return snapshot;
};
text._append = append = function(newOp, c) {
  var last, _ref, _ref2;
  if (c['i'] === '' || c['d'] === '') {
    return;
  }
  if (newOp.length === 0) {
    return newOp.push(c);
  } else {
    last = newOp[newOp.length - 1];
    if ((last['i'] != null) && (c['i'] != null) && (last['p'] <= (_ref = c['p']) && _ref <= (last['p'] + last['i'].length))) {
      return newOp[newOp.length - 1] = {
        'i': strInject(last['i'], c['p'] - last['p'], c['i']),
        'p': last['p']
      };
    } else if ((last['d'] != null) && (c['d'] != null) && (c['p'] <= (_ref2 = last['p']) && _ref2 <= (c['p'] + c['d'].length))) {
      return newOp[newOp.length - 1] = {
        'd': strInject(c['d'], last['p'] - c['p'], last['d']),
        'p': c['p']
      };
    } else {
      return newOp.push(c);
    }
  }
};
text.compose = compose = function(op1, op2) {
  var c, newOp, _i, _len;
  checkValidOp(op1);
  checkValidOp(op2);
  newOp = op1.slice();
  for (_i = 0, _len = op2.length; _i < _len; _i++) {
    c = op2[_i];
    append(newOp, c);
  }
  return newOp;
};
text.compress = compress = function(op) {
  return compose([], op);
};
text.normalize = function(op) {
  var c, newOp, _i, _len, _ref;
  newOp = [];
  if ((op['i'] != null) || (op['p'] != null)) {
    op = [op];
  }
  for (_i = 0, _len = op.length; _i < _len; _i++) {
    c = op[_i];
        if ((_ref = c['p']) != null) {
      _ref;
    } else {
      c['p'] = 0;
    };
    append(newOp, c);
  }
  return newOp;
};
invertComponent = function(c) {
  if (c['i'] != null) {
    return {
      'd': c['i'],
      'p': c['p']
    };
  } else {
    return {
      'i': c['d'],
      'p': c['p']
    };
  }
};
text.invert = function(op) {
  var c, _i, _len, _ref, _results;
  _ref = op.slice().reverse();
  _results = [];
  for (_i = 0, _len = _ref.length; _i < _len; _i++) {
    c = _ref[_i];
    _results.push(invertComponent(c));
  }
  return _results;
};
makeComposable = function(op) {
  var c, clength, distance, elem, head, offset, prev, remainder, type, _i, _len, _results;
  head = null;
  _results = [];
  for (_i = 0, _len = op.length; _i < _len; _i++) {
    c = op[_i];
    type = c['i'] !== void 0 ? 'i' : 'd';
    clength = c[type].length;
    offset = c['p'];
    _results.push((function() {
      if (head === null) {
        return head = {
          offset: offset,
          type: type,
          len: clength,
          next: null
        };
      } else {
        prev = null;
        elem = head;
        while (elem !== null) {
          distance = t === 'd' ? elem.offset : elem.offset + elem.len;
          if (offset < distance) {
            break;
          }
          offset -= distance;
          prev = elem;
          elem = elem.next;
        }
        if (elem === null) {
          return prev.next = {
            offset: offset,
            type: type,
            len: clength,
            next: null
          };
        } else {
          remainder = d - offset;
          composable[idx][1] -= offset;
          if (remainder > 0) {
            composable.splice(idx, 0, [t, remainder]);
          }
          if (type === 'i') {
            return composable.splice(idx, 0, [type, clength]);
          }
        }
      }
    })());
  }
  return _results;
};
text.transform = function(op1, op2, type) {};
if (typeof WEB !== "undefined" && WEB !== null) {
  exports.types || (exports.types = {});
  exports.types['text'] = text;
} else {
  module.exports = text;
}