# Text document API for text

text = require './text' unless WEB?

text.api =
	provides: {'text':true}

	# The number of characters in the string
	getLength: -> @snapshot.length

	# Get the text contents of a document
	getText: -> @snapshot

	insert: (text, pos, callback) ->
		pos = 0 unless pos?
		op = [{'p':pos, 'i':text}]
		
		@submitOp op, callback
		op
	
	del: (length, pos, callback) ->
		op = [{'p':pos, 'd':@snapshot[pos...(pos + length)]}]

		@submitOp op, callback
		op
	
	_register: ->
		@on 'remoteop', (op) ->
			for component in op
				if component['i'] != undefined
					@emit 'insert', component['i'], component['p']
				else
					@emit 'delete', component['d'], component['p']

text.api['provides'] = text.api.provides
text.api['getLength'] = text.api.getLength
text.api['getText'] = text.api.getText
text.api['insert'] = text.api.insert
text.api['del'] = text.api.del
